#!/usr/bin/php -q

/*
 * MySQLCDRGenerator.php
 * 
 * Copyright 2012 ShadoWalkeR <archer2006@list.ru>
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 * * Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above
 *   copyright notice, this list of conditions and the following disclaimer
 *   in the documentation and/or other materials provided with the
 *   distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * 
 */
 
<?php

//********************************************************************//
//***************************КОНФИГУРАЦИЯ*****************************//
//********************************************************************//

//Подгружаем конфигурацию
include('config.php');

//Подгружаем определения функций
include_once('functions.php');

//Подключение к MySQL
if (!mysql_connect($hostname,$dblogin,$dbpassword))
{
	SendReportToLog('ERROR: MySQL not connected');
    exit(1);
}
SendReportToLog('INFO: MySQL connected');



//********************************************************************//
//**********************ОСНОВНОЙ*ЦИКЛ*СКРИПТА*************************//
//********************************************************************//

//Счетчик записей CDR
$CDRs = 0;

//Запрашиваем все завершенные звонки, но не занесенные в cdrs
$BYEArray = MySQLGetBYEs($dbname);

//Основной цикл - для каждого BYE ищем INVITE и генерируем CDR
//запись, с проставлением отметки об этом в таблице acc
while ($BYE = mysql_fetch_assoc($BYEArray))
{
	$INVITE = MySQLGetINVITE($dbname,
							$BYE["from_tag"],
							$BYE["to_tag"],
							$BYE["callid"]);
	//В некоторых транзакциях поля from_tag и to_tag поменены местами
	//в запросах BYE и INVITE.
	if ($INVITE == "0")
	{
		$INVITE = MySQLGetINVITE($dbname,
								$BYE["to_tag"],
								$BYE["from_tag"],
								$BYE["callid"]);
	};
	
	//Вычисляем длятельность разговора
	$Lenght = DialogLenght($INVITE["time"],$BYE["time"]);
	
	//Генерируем CDR
	$cdr_id = GenerateCDR($dbname,$INVITE,$Lenght);
	
	//Задаем cdr_id в таблице acc
	SetCDRID($dbname,$cdr_id,$INVITE["callid"]);
	
	//Увеличиваем счетчик записей		
	$CDRs++;
}
	
//Логируем количество записей
SendReportToLog("INFO: Generated $CDRs cdrs");

exit(1);
?>
